//+------------------------------------------------------------------+
//|                                                 Advanced_ADX.mq4 |
//|                              Copyright  2006, Eng. Waddah Attar |
//|                                          waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Waddah Attar"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Green
#property indicator_color2     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_levelcolor MediumOrchid
//----
extern int    ADXPeriod        = 13;
extern double adxLevel         = 20;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundFile        = "alert2.wav";

//----
double ExtBuffer1[];
double ExtBuffer2[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ExtBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend1);
   SetIndexBuffer(3,trend2);
   SetLevelValue(0,adxLevel);
   IndicatorShortName("Advanced_ADX (" + ADXPeriod + ")");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double ADX0 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,  i);
      double ADX1 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,i);
      double ADX2 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,i);
      
      //
      //
      //
      //
      //
      
      ExtBuffer1[i] = EMPTY_VALUE;
      ExtBuffer2[i] = EMPTY_VALUE;
      trend1[i] = trend1[i+1];
      if(ADX1 >= ADX2) trend1[i] = 1;
      if(ADX1 <= ADX2) trend1[i] =-1;
      if(trend1[i] == 1)ExtBuffer1[i] = ADX0;
      if(trend1[i] ==-1)ExtBuffer2[i] = ADX0; 
      
      trend2[i] = trend2[i+1];
      if(ADX0>adxLevel)trend2[i] = 1;
      if(ADX0<adxLevel)trend2[i] =-1;      
     }
     
     //
     //
     //
     //
     //
      
     if (alertsOn)
     {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;
       if (trend2[whichBar] != trend2[whichBar+1])
       if (trend2[whichBar] == 1)
             doAlert("Trending");
       else  doAlert("Not Trending");       
   }
   return(0);
  }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Advanced ADX ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Advanced ADX "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

